--Texture registering
local surface = AceLibrary("Surface-1.0")
surface:Register("Otravi", "Interface\\AddOns\\OminousCastingBar\\Textures\\otravi")
surface:Register("Smooth", "Interface\\AddOns\\OminousCastingBar\\Textures\\smooth")
surface:Register("Glaze", "Interface\\AddOns\\OminousCastingBar\\Textures\\glaze")
surface:Register("Charcoal", "Interface\\AddOns\\OminousCastingBar\\Textures\\Charcoal")
surface:Register("BantoBar", "Interface\\AddOns\\OminousCastingBar\\Textures\\default")
local PaintChips = AceLibrary("PaintChips-2.0")
local waterfall = AceLibrary("Waterfall-1.0")

local L = AceLibrary("AceLocale-2.2"):new("OminousCastingBar")

L:RegisterTranslations("enUS", function()
return {
	["Show"] = true,
	["Show a casting bar"] = true,
	["Open"] = true,
	["Open waterfall config"] = true,
	["Casting Bar"] = true,
	["Casting Bar settings"] = true,
	["Icon"] = true,
	["Icon options"] = true,
	["Height"] = true,
	["Set the bar Height."] = true,
	["Width"] = true,
	["Set the bar Width."] = true,
	["Scale"] = true,
	["Set the bar scale."] = true,
	["PosX"] = true,
	["Set the bars x cordinate."] = true,
	["PosY"] = true,
	["Set the bars y cordinate."] = true,
	["Texture"] = true,
	["Set the texture for the timer bars."] = true,
	["Complete Color"] = true,
	["Complete color of bar"] = true,
	["Casting Color"] = true,
	["Casting color of bar"] = true,
	["Channel Color"] = true,
	["Channel color of bar"] = true,
	["Failed Color"] = true,
	["Failed color of bar"] = true,
	["Mirror Bar"] = true,
	["Mirror Bar settings"] = true,
}
end)

L:RegisterTranslations("koKR", function()
return {
	["Open"] = "열기",
	["Open waterfall config"] = "GUI 설정창을 엽니다",
	["Casting Bar"] = "시전바",
	["Casting Bar settings"] = "시전바의 설정을 변경합니다",
	["Icon"] = "아이콘",
	["Icon options"] = "아이콘 설정",
	["Height"] = "높이",
	["Set the bar Height."] = "바의 높이를 설정합니다.",
	["Width"] = "너비",
	["Set the bar Width."] = "바의 너비를 설정합니다.",
	["Scale"] = "크기",
	["Set the bar scale."] = "바의 크기를 설정합니다.",
	["PosX"] = "가로 위치",
	["Set the bars x cordinate."] = "바의 가로 위치를 설정합니다.",
	["PosY"] = "세로 위치",
	["Set the bars y cordinate."] = "바의 세로 위치를 설정합니다.",
	["Texture"] = "텍스쳐",
	["Set the texture for the timer bars."] = "바의 텍스쳐를 설정합니다.",
	["Complete Color"] = "완료 색상",
	["Complete color of bar"] = "주문 시전 완료시 바의 색상을 설정합니다",
	["Casting Color"] = "시전 색상",
	["Casting color of bar"] = "주문 시전 시 바의 색상을 설정합니다",
	["Channel Color"] = "채널링 색상",
	["Channel color of bar"] = "채널링 주문 시전 시 바의 색상을 설정합니다",
	["Failed Color"] = "실패 색상",
	["Failed color of bar"] = "주문 시전 실패시 바의 색상을 설정합니다",
	["Mirror Bar"] = "미러바",
	["Mirror Bar settings"] = "미러바의 설정을 변경합니다",
}
end)

--Ace2 Registering 
OminousCastingBar = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "CandyBar-2.0")

--Mod Options
OminousCastingBar.Menu = { 
type ="group",
args = {
	Open = {
		name = L["Open"],
		desc = L["Open waterfall config"],
		type = "execute", 
		order = 1,
		func = function() waterfall:Open("OminousCastingBar") end,
	},
	CastingBar = {
		type = "group",
		name = L["Casting Bar"],
		desc = L["Casting Bar settings"],
		order = 2,
		args = {
			Show = {
				type = "execute",
				name = L["Show"],
				desc = L["Show a casting bar"],
				func = "testCB",
			},
			Icon = {
				type = "text",
				order = 1,
				name = L["Icon"],
				desc = L["Icon options"],
				get = function() return OminousCastingBar.db.profile.CastingBar.Icon end,
				set = function(v) OminousCastingBar.db.profile.CastingBar.Icon = v end,
				validate = {"LEFT", "RIGHT", "NONE"},
			},
			Height = {
				type = "range",
				order = 2,
				name = L["Height"],
				desc = L["Set the bar Height."],
				min = 10,
				max = 100,
				step = 1,
				get = function() return OminousCastingBar.db.profile.CastingBar.height end,
				set = function(v) OminousCastingBar.db.profile.CastingBar.height = v 
					OminousCastingBar:SetCandyBarHeight("OminousCastingBar", OminousCastingBar.db.profile.CastingBar.height) end,
			},
			Width = {
				type = "range",
				order = 3,
				name = L["Width"],
				desc = L["Set the bar Width."],
				min = 100,
				max = 1000,
				step = 1,
				get = function() return OminousCastingBar.db.profile.CastingBar.width end,
				set = function(v) OminousCastingBar.db.profile.CastingBar.width = v 
					OminousCastingBar:SetCandyBarWidth("OminousCastingBar", OminousCastingBar.db.profile.CastingBar.width)end,
			},
			Scale = {
				type = "range",
				order = 4,
				name = L["Scale"],
				desc = L["Set the bar scale."],
				min = 0.2,
				max = 2.0,
				step = 0.1,
				get = function() return OminousCastingBar.db.profile.CastingBar.Scale end,
				set = function(v) OminousCastingBar.db.profile.CastingBar.Scale = v 
					OminousCastingBar:SetCandyBarScale("OminousCastingBar", OminousCastingBar.db.profile.CastingBar.Scale)end,
			},
			PosX = {
				type = "range",
				order = 5,
				name = L["PosX"],
				desc = L["Set the bars x cordinate."],
				min = 0,
				max = math.floor(GetScreenWidth()),
				step = 1,
				get = function() return OminousCastingBar.db.profile.CastingBar.posx end,
				set = function(v) OminousCastingBar.db.profile.CastingBar.posx = v 
					OminousCastingBar:SetCandyBarPoint("OminousCastingBar", "CENTER", "UIParent", "BOTTOMLEFT", OminousCastingBar.db.profile.CastingBar.posx, OminousCastingBar.db.profile.CastingBar.posy) end,
			},
			PosY = {
				type = "range",
				order = 6,
				name = L["PosY"],
				desc = L["Set the bars y cordinate."],
				min = 0,
				max = math.floor(GetScreenHeight()),
				step = 1,
				get = function() return OminousCastingBar.db.profile.CastingBar.posy end,
				set = function(v) OminousCastingBar.db.profile.CastingBar.posy = v 
					OminousCastingBar:SetCandyBarPoint("OminousCastingBar", "CENTER", "UIParent", "BOTTOMLEFT", OminousCastingBar.db.profile.CastingBar.posx, OminousCastingBar.db.profile.CastingBar.posy) end,
			},
			Texture = {
				type = "text",
				order = 7,
				name = L["Texture"],
				desc = L["Set the texture for the timer bars."],
				get = function() return OminousCastingBar.db.profile.texture end,
				set = function(v) OminousCastingBar.db.profile.texture = v 
					OminousCastingBar:SetCandyBarTexture( "OminousCastingBar", surface:Fetch( OminousCastingBar.db.profile.texture) )end,
				validate = surface:List(),
			},
			CompleteColor = {
				name = L["Complete Color"],
				desc = L["Complete color of bar"],
				order = 8,
				type = "color",
				get = function() local _, r, g, b = PaintChips:GetRGBPercent(OminousCastingBar.db.profile.CastingBar.Colors.Complete); return r, g, b end,
				set = function(r, g, b, a) local hex = OminousCastingBar:RGBToHex(r, g, b); PaintChips:RegisterHex(hex); OminousCastingBar.db.profile.CastingBar.Colors.Complete = hex end,
			},
			CastingColor = {
				name = L["Casting Color"],
				desc = L["Casting color of bar"],
				order = 8,
				type = "color",
				get = function() local _, r, g, b = PaintChips:GetRGBPercent(OminousCastingBar.db.profile.CastingBar.Colors.Casting); return r, g, b end,
				set = function(r, g, b, a) local hex = OminousCastingBar:RGBToHex(r, g, b); PaintChips:RegisterHex(hex); OminousCastingBar.db.profile.CastingBar.Colors.Casting = hex OminousCastingBar:SetCandyBarColor("OminousCastingBar", hex) end,
			},
			ChannelColor = {
				name = L["Channel Color"],
				desc = L["Channel color of bar"],
				order = 8,
				type = "color",
				get = function() local _, r, g, b = PaintChips:GetRGBPercent(OminousCastingBar.db.profile.CastingBar.Colors.Channel); return r, g, b end,
				set = function(r, g, b, a) local hex = OminousCastingBar:RGBToHex(r, g, b); PaintChips:RegisterHex(hex); OminousCastingBar.db.profile.CastingBar.Colors.Channel = hex end,
			},
			FailedColor = {
				name = L["Failed Color"],
				desc = L["Failed color of bar"],
				order = 8,
				type = "color",
				get = function() local _, r, g, b = PaintChips:GetRGBPercent(OminousCastingBar.db.profile.CastingBar.Colors.Failed); return r, g, b end,
				set = function(r, g, b, a) local hex = OminousCastingBar:RGBToHex(r, g, b); PaintChips:RegisterHex(hex); OminousCastingBar.db.profile.CastingBar.Colors.Failed = hex end,
			},
		},
	},
	MirrorBar = {
		type = "group",
		name = L["Mirror Bar"],
		desc = L["Mirror Bar settings"],
		order = 3,
		args = {
			Height = {
				type = "range",
				order = 2,
				name = L["Height"],
				desc = L["Set the bar Height."],
				min = 10,
				max = 100,
				step = 1,
				get = function() return OminousCastingBar.db.profile.MirrorBar.height end,
				set = function(v) OminousCastingBar.db.profile.MirrorBar.height = v 
					OminousCastingBar:SetCandyBarHeight("OminousMirrorBar", OminousCastingBar.db.profile.MirrorBar.height) end,
			},
			Width = {
				type = "range",
				order = 3,
				name = L["Width"],
				desc = L["Set the bar Width."],
				min = 100,
				max = 1000,
				step = 1,
				get = function() return OminousCastingBar.db.profile.MirrorBar.width end,
				set = function(v) OminousCastingBar.db.profile.MirrorBar.width = v 
					OminousCastingBar:SetCandyBarWidth("OminousMirrorBar", OminousCastingBar.db.profile.MirrorBar.width)end,
			},
			Scale = {
				type = "range",
				order = 4,
				name = L["Scale"],
				desc = L["Set the bar scale."],
				min = 0.2,
				max = 2.0,
				step = 0.1,
				get = function() return OminousCastingBar.db.profile.MirrorBar.Scale end,
				set = function(v) OminousCastingBar.db.profile.MirrorBar.Scale = v 
					OminousCastingBar:SetCandyBarScale("OminousMirrorBar", OminousCastingBar.db.profile.MirrorBar.Scale)end,
			},
			PosX = {
				type = "range",
				order = 5,
				name = L["PosX"],
				desc = L["Set the bars x cordinate."],
				min = 0,
				max = math.floor(GetScreenWidth()),
				step = 1,
				get = function() return OminousCastingBar.db.profile.MirrorBar.posx end,
				set = function(v) OminousCastingBar.db.profile.MirrorBar.posx = v 
					OminousCastingBar:SetCandyBarPoint("OminousMirrorBar", "CENTER", "UIParent", "BOTTOMLEFT", OminousCastingBar.db.profile.MirrorBar.posx, OminousCastingBar.db.profile.MirrorBar.posy) end,
			},
			PosY = {
				type = "range",
				order = 6,
				name = L["PosY"],
				desc = L["Set the bars y cordinate."],
				min = 0,
				max = math.floor(GetScreenHeight()),
				step = 1,
				get = function() return OminousCastingBar.db.profile.MirrorBar.posy end,
				set = function(v) OminousCastingBar.db.profile.MirrorBar.posy = v 
					OminousCastingBar:SetCandyBarPoint("OminousMirrorBar", "CENTER", "UIParent", "BOTTOMLEFT", OminousCastingBar.db.profile.MirrorBar.posx, OminousCastingBar.db.profile.MirrorBar.posy) end,
			},
			CompleteColor = {
				name = L["Complete Color"],
				desc = L["Complete color of bar"],
				order = 8,
				type = "color",
				get = function() local _, r, g, b = PaintChips:GetRGBPercent(OminousCastingBar.db.profile.CastingBar.Colors.Complete); return r, g, b end,
				set = function(r, g, b, a) local hex = OminousCastingBar:RGBToHex(r, g, b); PaintChips:RegisterHex(hex); OminousCastingBar.db.profile.CastingBar.Colors.Complete = hex end,
			},
		},
	},
}
}

local Defaults	= {
	CastingBar	= {
		width = 255,
		height = 25,
		Icon = "LEFT",
		Scale = 1,
		Colors = {
			Complete = "00FF00",
			Casting = "FFB300",
			Channel = "4D4DFF",
			Failed = "FF0000",
		},
		posy = GetScreenHeight()/4,
		posx = GetScreenWidth()/2,
	},
	MirrorBar = {
		width = 255,
		height = 25,
		Scale = 1,
		Colors = {
			EXHAUSTION = "FFE500",
			BREATH = "007FFF",
			DEATH = "00B3FF",
			FEIGNDEATH = "FFB3FF",
		},
		posy = GetScreenHeight()*3/4,
		posx = GetScreenWidth()/2,
	},
texture	= "Otravi",
}

function OminousCastingBar:OnInitialize()
--Revision
self.revision = tonumber(string.sub("$Rev: 29986 $", 7, -3))
self.version = self.version .. " |cffff8888r"..self.revision.."|r"
--Saved Information
OminousCastingBar:RegisterDB("OminousCastingBarDB")
OminousCastingBar:RegisterDefaults('profile', Defaults	)
waterfall:Register("OminousCastingBar", 'aceOptions', self.Menu, "treeType", "SECTIONS")
OminousCastingBar:RegisterChatCommand({"/OminousCastingBar", "/OCB"}, self.Menu)
end

function OminousCastingBar:OnEnable()
	self:RegisterEvent("UNIT_SPELLCAST_START")
	self:RegisterEvent("UNIT_SPELLCAST_FAILED", "CastFailed")
	self:RegisterEvent("UNIT_SPELLCAST_INTERRUPTED", "CastFailed")
	self:RegisterEvent("UNIT_SPELLCAST_DELAYED")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_START")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_UPDATE")
	self:RegisterEvent("UNIT_SPELLCAST_CHANNEL_STOP")
	self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
	
	self:RegisterEvent("MIRROR_TIMER_START")
	self:RegisterEvent("MIRROR_TIMER_PAUSE")
	self:RegisterEvent("MIRROR_TIMER_STOP")
	
	UIParent:UnregisterEvent("MIRROR_TIMER_START")
	
	self:RegHex(self.db.profile.CastingBar.Colors)
	self:HideBlizzCB()	
end

function OminousCastingBar:OnDisable()
self:ShowBlizzCB()
UIParent:RegisterEvent("MIRROR_TIMER_START")
end

function OminousCastingBar:testCB()
if not self:IsCandyBarRegistered("OminousCastingBar") then
self:RegisterCandyBar("OminousCastingBar", 1, "Testing a Bar!", "Interface\\Icons\\Ability_Sap", self.db.profile.CastingBar.Colors.Casting)
self:SetCandyBarIconPosition("OminousCastingBar", self.db.profile.CastingBar.Icon)
self:SetCandyBarBackgroundColor("OminousCastingBar", self.db.profile.CastingBar.Colors.Casting, 0.3)
self:SetCandyBarPoint("OminousCastingBar", "CENTER", "UIParent", "BOTTOMLEFT", self.db.profile.CastingBar.posx, self.db.profile.CastingBar.posy)
self:SetCandyBarHeight("OminousCastingBar", self.db.profile.CastingBar.height)
self:SetCandyBarWidth("OminousCastingBar", self.db.profile.CastingBar.width)
self:SetCandyBarTexture( "OminousCastingBar", surface:Fetch( self.db.profile.texture) )
self:SetCandyBarScale("OminousCastingBar", self.db.profile.CastingBar.Scale)
self:StartCandyBar("OminousCastingBar", true)
self:PauseCandyBar("OminousCastingBar")
else
self:UnregisterCandyBar("OminousCastingBar")
end
end

function OminousCastingBar:RegHex(hex)
	if type(hex) == "string" then
		PaintChips:RegisterHex(hex)
	elseif type(hex) == "table" then
		for _,hexx in pairs(hex) do
			self:RegHex(hexx)
		end
	end
end

function OminousCastingBar:RGBToHex(r, g, b)
	return format("%02x%02x%02x", r*255, g*255, b*255)
end

function OminousCastingBar:UNIT_SPELLCAST_START(a1)
if a1 ~= "player" then return end
local _, _, text, texture, startTime, endTime = UnitCastingInfo("player")
self:SetupCastingBar("OminousCastingBar", text, texture, startTime, endTime, true, "Casting")
end

function OminousCastingBar:UNIT_SPELLCAST_DELAYED(a1)
if a1 ~= "player" then return end
local _, _, _, _, startTime, endTime = UnitCastingInfo("player")
self:SetCandyBarTimeLeft("OminousCastingBar", (endTime-startTime)/1000)
end

function OminousCastingBar:CastFailed(a1)
if a1 ~= "player" then return end
if (AceLibrary("AceEvent-2.0").currentEvent == "UNIT_SPELLCAST_FAILED") then
self:SetCandyBarText("OminousCastingBar", FAILED)
else
self:SetCandyBarText("OminousCastingBar", INTERRUPTED)
end
self:SetCandyBarColor("OminousCastingBar", self.db.profile.CastingBar.Colors.Failed)
self:SetCandyBarBackgroundColor("OminousCastingBar", self.db.profile.CastingBar.Colors.Failed, .3)
self:StopCandyBar("OminousCastingBar")
end

function OminousCastingBar:UNIT_SPELLCAST_SUCCEEDED(a1)
if a1 ~= "player" then return end
self:SetCandyBarColor("OminousCastingBar", self.db.profile.CastingBar.Colors.Complete)
end

function OminousCastingBar:UNIT_SPELLCAST_CHANNEL_START(a1)
if a1 ~= "player" then return end
local _, _, text, texture, startTime, endTime = UnitChannelInfo("player")
self:SetupCastingBar("OminousCastingBar", text, texture, startTime, endTime, false, "Channel")
self.endTime = endTime
end

function OminousCastingBar:UNIT_SPELLCAST_CHANNEL_UPDATE(a1)
if a1 ~= "player" then return end
local _, _, _, _, startTime, endTime = UnitChannelInfo("player")
local _, t, e = self:CandyBarStatus("OminousCastingBar")
local time = t-e-((self.endTime - endTime)/1000)
self:SetCandyBarTimeLeft("OminousCastingBar", time > 0 and time or 0)
end

function OminousCastingBar:UNIT_SPELLCAST_CHANNEL_STOP(a1)
if a1 ~= "player" then return end
self:StopCandyBar("OminousCastingBar")
end

function OminousCastingBar:SetupCastingBar(bar, text, texture, startTime, endTime, channel, type)
self:RegisterCandyBar(bar, (endTime-startTime)/1000, text, self.db.profile.CastingBar.Icon ~= "NONE" and texture or nil, self.db.profile.CastingBar.Colors[type])
self:SetCandyBarIconPosition(bar, self.db.profile.CastingBar.Icon)
self:SetCandyBarBackgroundColor(bar, self.db.profile.CastingBar.Colors[type], 0.3)
self:SetCandyBarReversed(bar, channel)
self:SetCandyBarPoint(bar, "CENTER", "UIParent", "BOTTOMLEFT", self.db.profile.CastingBar.posx, self.db.profile.CastingBar.posy)
self:SetCandyBarFade(bar, 1)
self:SetCandyBarHeight(bar, self.db.profile.CastingBar.height)
self:SetCandyBarWidth(bar, self.db.profile.CastingBar.width)
self:SetCandyBarTexture( bar, surface:Fetch( self.db.profile.texture) )
self:SetCandyBarScale(bar, self.db.profile.CastingBar.Scale)
self:StartCandyBar(bar, true)
end

function OminousCastingBar:ShowBlizzCB()
	CastingBarFrame["Show"] = self.BlizzShow
end

function OminousCastingBar:HideBlizzCB()
	if(not self.BlizzShow) then self.BlizzShow = CastingBarFrame["Show"] end
	CastingBarFrame["Show"] = function() end
end

function OminousCastingBar:SetupMirrorBar(bar, type, text, atime, time, value)
self:RegisterCandyBar(bar, time/1000, text, nil, self.db.profile.MirrorBar.Colors[type])
self:SetCandyBarBackgroundColor(bar, self.db.profile.MirrorBar.Colors[type], 0.3)
self:SetCandyBarPoint(bar, "CENTER", "UIParent", "BOTTOMLEFT", self.db.profile.MirrorBar.posx, self.db.profile.MirrorBar.posy)
self:SetCandyBarFade(bar, 1)
self:SetCandyBarHeight(bar, self.db.profile.MirrorBar.height)
self:SetCandyBarWidth(bar, self.db.profile.MirrorBar.width)
self:SetCandyBarTexture( bar, surface:Fetch( self.db.profile.texture) )
self:SetCandyBarScale(bar, self.db.profile.MirrorBar.Scale)
self:StartCandyBar(bar, true)
if value == -1 then
self:CancelScheduledEvent("OminousMirrorBarAddidng")
self:SetCandyBarTimeLeft(bar, atime/1000)
elseif value > 0 then
self:SetCandyBarTimeLeft(bar, atime/1000)
self:ScheduleRepeatingEvent("OminousMirrorBarAddidng", function() local _, v, e = self:CandyBarStatus(bar) self:SetCandyBarTimeLeft(bar, v-e + 1) end, 1/value)
end
end

function OminousCastingBar:MIRROR_TIMER_START(timer, value, maxvalue, scale, paused, label)
self:SetupMirrorBar("OminousMirrorBar", timer, label, value, maxvalue, scale)
end 

function OminousCastingBar:MIRROR_TIMER_PAUSE(value)
if value > 0 then
self:PauseCandyBar("OminousMirrorBar")
self:CancelScheduledEvent("OminousMirrorBarAddidng")
else
self:StartCandyBar("OminousMirrorBar")
end
end

function OminousCastingBar:MIRROR_TIMER_STOP()
self:StopCandyBar("OminousMirrorBar")
self:CancelScheduledEvent("OminousMirrorBarAddidng")
end 